﻿----------------------------------------------------------------------------------------------------------
-- Author: Montagge@Seastone
-- With lots of help from TimeBomb.  Thank you, good sir!
-- Version: 1.10

-- There is no copyright on this code

-- Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
-- associated documentation files (the "Software"), to deal in the Software without restriction, including
-- without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the Software is furnished to do so.

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
-- LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
-- NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
-- SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
----------------------------------------------------------------------------------------------------------

MoneyBar = {}


local defaultFilter = {
					"Platinum",
					"Favor",
					"Artisan Mark",
					"Planarite"
}

local defaultSave = {
					x = 0,
					y = 1010,
					alpha = 0.3,
					scale = 1750,
					barr = 0,
					barg = 0,
					barb = 0,
					textr = 1,
					textg = 1,
					textb = 1,
					orient = 'horiz',
					filter = defaultFilter
};

local defaultScale = {
                        vert = 1000,
                        horiz = 1750,
};

local currency = {}

moneybar_main = UI.CreateContext("UI")
local bar = UI.CreateFrame("Frame","Bar",moneybar_main)

local plati = UI.CreateFrame("Texture","Platinum",moneybar_main)
local gold = UI.CreateFrame("Texture","Gold",moneybar_main)
local silver = UI.CreateFrame("Texture","Silver",moneybar_main)
local pvp_icon = UI.CreateFrame("Texture","Favor",moneybar_main) 
local master_plaq = UI.CreateFrame("Texture","Master Craftsmen Mark",moneybar_main)
local art_mark = UI.CreateFrame("Texture","Artisan Mark",moneybar_main)
local planarite = UI.CreateFrame("Texture","Planarite",moneybar_main)
local corr_ss = UI.CreateFrame("Texture","Corrupted Sourcestone",moneybar_main)
local curse_ss = UI.CreateFrame("Texture","Cursed Sourcestone",moneybar_main)
local vile_ss = UI.CreateFrame("Texture","Vile Sourcestone",moneybar_main)
local in_ss = UI.CreateFrame("Texture","Inscribed Sourcestone",moneybar_main)
local luck_coin = UI.CreateFrame("Texture","Lucky Coin",moneybar_main)
local achieve_plaq = UI.CreateFrame("Texture","Plaque of Achievement",moneybar_main)
local moa = UI.CreateFrame("Texture","Mark of Ascension",moneybar_main)
local gmoa = UI.CreateFrame("Texture","Greater Mark of Ascension",moneybar_main)
local imoa = UI.CreateFrame("Texture","Infernal Mark of Ascension",moneybar_main)
local moc = UI.CreateFrame("Texture","Mark of Conquest",moneybar_main)
local unsnow = UI.CreateFrame("Texture","Unique Snowflake",moneybar_main)
local prizetick = UI.CreateFrame("Texture","Prize Ticket",moneybar_main)
local glassbead = UI.CreateFrame("Texture","Glass Beads",moneybar_main)
local summermb = UI.CreateFrame("Texture","Summerfest Merit Badge",moneybar_main)
local frbrace  = UI.CreateFrame("Texture","Summerfest Friendship Bracelet",moneybar_main)
local empyreal_ss = UI.CreateFrame("Texture","Empyreal Sourcestone",moneybar_main)
local aut_harvest_as = UI.CreateFrame("Texture","Autumn Harvest Ambersap",moneybar_main)
local aut_harvest_sig = UI.CreateFrame("Texture","Autumn Harvest Signet",moneybar_main)
local infinity_stone = UI.CreateFrame("Texture","Infinity Stone",moneybar_main)
local master_mark = UI.CreateFrame("Texture","Master Craftsman's Mark",moneybar_main)
local free_moc = UI.CreateFrame("Texture","Freelancer's Mark of Conquest",moneybar_main)
local empyreal_sm = UI.CreateFrame("Texture","Empyreal Slayer's Mark",moneybar_main)
local frozen_es = UI.CreateFrame("Texture","Frozen Eclipse Stone",moneybar_main)
local grand_master = UI.CreateFrame("Texture","Grandmaster Craftman's Mark",moneybar_main)


	
local plati_text = UI.CreateFrame("Text","Platinum",moneybar_main)
local gold_text = UI.CreateFrame("Text","Gold",moneybar_main)
local silver_text = UI.CreateFrame("Text","Silver",moneybar_main)
local favor = UI.CreateFrame("Text","Favor",moneybar_main)
local master_plaq_text = UI.CreateFrame("Text","Master Craftsman's Mark",moneybar_main)
local art_text = UI.CreateFrame("Text","Artisan's Mark",moneybar_main)
local plan_text = UI.CreateFrame("Text","Planarite",moneybar_main)
local corr_text = UI.CreateFrame("Text","Corrupted Sourcestone",moneybar_main)
local curse_text = UI.CreateFrame("Text","Cursed Sourcestone",moneybar_main)
local vile_text = UI.CreateFrame("Text","Vile Sourcestone",moneybar_main)
local in_text = UI.CreateFrame("Text","Inscribed Sourcestone",moneybar_main)
local luck_text = UI.CreateFrame("Text","Lucky Coin",moneybar_main)
local ap_text = UI.CreateFrame("Text","Plaques of Achievement",moneybar_main)
local moa_text = UI.CreateFrame("Text","Marks of Ascension",moneybar_main)
local gmoa_text = UI.CreateFrame("Text","Greater Marks of Ascension",moneybar_main)
local imoa_text = UI.CreateFrame("Text","Infernal Mark of Ascension",moneybar_main)
local moc_text = UI.CreateFrame("Text","Mark of Conquest",moneybar_main)
local unsnow_text = UI.CreateFrame("Text","Unique Snowflake",moneybar_main)
local prizetick_text = UI.CreateFrame("Text","Prize Ticket",moneybar_main)
local glassbead_text = UI.CreateFrame("Text","Glass Beads",moneybar_main)
local summermb_text = UI.CreateFrame("Text","Summerfext Merit Badge",moneybar_main)
local frbrace_text  = UI.CreateFrame("Text","Summerfest Friendship Bracelet",moneybar_main)
local empyreal_text = UI.CreateFrame("Text","Empyreal Sourcestone",moneybar_main)
local aut_harvest_as_text = UI.CreateFrame("Text","Autumn Harvest Ambersap",moneybar_main)
local aut_harvest_sig_text = UI.CreateFrame("Text","Autumn Harvest Signet",moneybar_main)
local infinity_text = UI.CreateFrame("Text","Infinity Stone",moneybar_main)
local master_mark_text = UI.CreateFrame("Text","Master Craftsman's Mark",moneybar_main)

local MoneyBarIcons = {
					plati,
					gold,
					silver,
					pvp_icon,
					moc,
					master_plaq,
					art_mark,
					planarite,
					corr_ss,
					curse_ss,
					vile_ss,
					in_ss,
					luck_coin,
					achieve_plaq,
					moa,
					gmoa,
					imoa,
					unsnow,
					prizetick,
					glassbead,
					summermb,
					frbrace,
					empyreal_ss,
					aut_harvest_as,
					aut_harvest_sig,
					infinity_stone,
					master_mark,
					free_moc,
					empyreal_sm,
					frozen_es,
					grand_master
}

local MoneyBarText = {
					plati_text,
					gold_text,
					silver_text,
					favor,
					moc_text,
					master_plaq_text,
					art_text,
					plan_text,
					corr_text,
					curse_text,
					vile_text,
					in_text,
					luck_text,
					ap_text,
					moa_text,
					gmoa_text,
					imoa_text,
					unsnow_text,
					prizetick_text,
					glassbead_text,
					summermb_text,
					frbrace_text,
					empyreal_text,
					aut_harvest_as_text,
					aut_harvest_sig_text,
					infinity_text,
					master_mark_text
}

local MoneyBarLength = table.maxn(MoneyBarText)

-- Configure Frames and set initial conditions
function MoneyBar.Initialize(a)
	if a ~= "Money" then
		return
	end
	if not MoneyBarSave then
		MoneyBarSave = defaultSave
	end
	MoneyBar.GetCurrency()
	MoneyBar.BuildFilter()
	MoneyBar.BuildAll()
    print("Money Bar loaded.")
end

function MoneyBar.BuildAll()
	MoneyBar.GetCurrency()
	MoneyBar.BuildBar()
	MoneyBar.BuildIcons()
	MoneyBar.BuildTextFrames()
	MoneyBar.SetText()
end

function MoneyBar.WorkAround(mb_units)
	for _,specifier in pairs(mb_units) do
		if specifier == "player" then
			MoneyBar.BuildAll()
			break
		end
	end
end

-- Sets the parameters for the bar
function MoneyBar.BuildBar()
	bar:SetPoint("TOPLEFT",moneybar_main,"TOPLEFT",MoneyBarSave.x,MoneyBarSave.y)
	bar:SetBackgroundColor(MoneyBarSave.barr,MoneyBarSave.barg,MoneyBarSave.barb)
	if MoneyBarSave.orient == "vert" then
		bar:SetHeight(MoneyBarSave.scale)
        bar:SetWidth(75)
	else
		bar:SetWidth(MoneyBarSave.scale)
        bar:SetHeight(15)
	end
	bar:SetAlpha(MoneyBarSave.alpha)
	bar:SetLayer(0)
	bar:SetVisible(true)
	bar.fixedPos = true
	function bar.Event:LeftDown()
		if bar.fixedPos then
			return
		end
		bar.leftDown = true
		local mouse = Inspect.Mouse()
		bar.originalXDiff = mouse.x - bar:GetLeft()
		bar.originalYDiff = mouse.y - bar:GetTop()
		local left, top, right, bottom = bar:GetBounds()
	end
	function bar.Event:LeftUp()
		if bar.fixedPos then
			return
		end
		bar.leftDown = false
	end
	function bar.Event:LeftUpoutside()
		if bar.fixedPos then
			return
		end
		bar.leftDown = false
	end
	function bar.Event:MouseMove(x, y)
		if bar.fixedPos then
			return
		end
		if not bar.leftDown then
			return
		end
		local newX = x - self.originalXDiff
		local newY = y - self.originalYDiff
		bar:SetPoint("TOPLEFT", UIParent, "TOPLEFT", newX, newY)
		MoneyBarSave.x = newX
		MoneyBarSave.y = newY
	end
end

-- Sets the parameters for the icons
function MoneyBar.BuildIcons()
	for i=1,table.maxn(MoneyBarIcons),1 do
		--MoneyBarIcons[i]:ClearAll()
		MoneyBarIcons[i]:SetVisible(false)
	end
	local barScaleWidth = 0
    local barScaleHeight = 0
	if MoneyBarSave.orient == "vert" then
        barScaleHeight = bar:GetHeight()
    else
        barScaleWidth = bar:GetWidth()
	end
	local mb_currinfo = {}
	local mb_list = Inspect.Currency.List()
	for id,_ in pairs(mb_list) do
		local mb_info = Inspect.Currency.Detail(id)
		local mb_temp_table = {name = mb_info.name,icon = mb_info.icon}
		table.insert(mb_currinfo,mb_temp_table)
	end
	local MoneyBarFilterLength = table.maxn(MoneyBarSave.filter)
	for i=1,table.maxn(MoneyBarSave.filter),1 do
		for j=1,table.maxn(mb_currinfo),1 do
			if MoneyBarSave.filter[i] == mb_currinfo[j].name or MoneyBarSave.filter[i] == "Platinum" then
				if MoneyBarSave.filter[i] == "Platinum" then
					MoneyBarIcons[i]:SetTexture("Money","plat.png")
					MoneyBarIcons[i]:SetPoint("TOPLEFT",bar,"TOPLEFT",barScaleWidth*((i-1)/(MoneyBarFilterLength)),barScaleHeight*((i-1)/(MoneyBarFilterLength)))
					MoneyBarIcons[i]:SetHeight(15)
					MoneyBarIcons[i]:SetWidth(15)
					MoneyBarIcons[i]:SetLayer(2)
					MoneyBarIcons[i]:SetVisible(true)
				else
					MoneyBarIcons[i]:SetTexture("Rift",mb_currinfo[j].icon)
					MoneyBarIcons[i]:SetPoint("TOPLEFT",bar,"TOPLEFT",barScaleWidth*((i-1)/(MoneyBarFilterLength)),barScaleHeight*((i-1)/(MoneyBarFilterLength)))
					MoneyBarIcons[i]:SetHeight(15)
					MoneyBarIcons[i]:SetWidth(15)
					MoneyBarIcons[i]:SetLayer(2)
					MoneyBarIcons[i]:SetVisible(true)
				break
				end
			end
		end
	end
end

-- Sets the parameters for the text frames
function MoneyBar.BuildTextFrames()
    for i=1,table.maxn(MoneyBarSave.filter),1 do
        MoneyBarText[i]:SetFontColor(MoneyBarSave.textr,MoneyBarSave.textg,MoneyBarSave.textb,1)
    end
	for i=1,table.maxn(MoneyBarSave.filter),1 do
		if MoneyBarIcons[i]:GetVisible() then
			MoneyBarText[i]:SetLayer(2)
			MoneyBarText[i]:SetVisible(true)
		--	MoneyBarText[i]:SetWordwrap(true)
			MoneyBarText[i]:SetWidth(200)
			if MoneyBarSave.orient == "vert" then
				MoneyBarText[i]:SetPoint("TOPLEFT",bar,"TOPLEFT",0,MoneyBarIcons[i]:GetBottom())
			else
				MoneyBarText[i]:SetPoint("TOPLEFT",bar,"TOPLEFT",MoneyBarIcons[i]:GetRight(),0)
			end
		else
			MoneyBarText[i]:SetVisible(false)
		end
	end
end

-- Get the table of currencies
function MoneyBar.GetCurrency()
  local list = Inspect.Currency.List()
  for k,j in pairs(list) do
       currency[j] = Inspect.Currency.Detail(k)
	    -- if currency[j].icon then
			-- print(currency[j].name .. " : " .. currency[j].id)
		-- end
  end
end

-- Sets the text frames to the amount of each currency
function MoneyBar.SetText()
    MoneyBar.ClearText()
    MoneyBar.TextLoc()
	local mb_currinfo = {}
	local mb_list = Inspect.Currency.List()
	for id,_ in pairs(mb_list) do
		local mb_info = Inspect.Currency.Detail(id)
		local mb_temp_table = {name = mb_info.name,id = mb_info.id}
		table.insert(mb_currinfo,mb_temp_table)
	end
	for i=1,table.maxn(MoneyBarSave.filter),1 do
		for j=1,table.maxn(mb_currinfo),1 do
			if MoneyBarSave.filter[i] == mb_currinfo[j].name or MoneyBarSave.filter[i] == "Platinum" then
				if MoneyBarSave.filter[i] == "Platinum" then
					local len = string.len(MoneyBar.GetStack("coin"))
					if len <= 4 then
						MoneyBarText[i]:SetText("0")
					else
						MoneyBarText[i]:SetText(string.sub(MoneyBar.GetStack("coin"),1,len-4))
					end
				else
					--print(mb_currinfo[j].name .. mb_currinfo[j].id)
					MoneyBarText[i]:SetText(MoneyBar.GetStack(mb_currinfo[j].id))
				end
			end
		end
	end
	-- gold_text:SetText(string.sub(MoneyBar.GetStack("coin"),len-3,len-2))
	-- silver_text:SetText(string.sub(MoneyBar.GetStack("coin"),len-1,len))
end

-- Should clear text frame to prevent text messiness.
function MoneyBar.ClearText()
	for i=1,MoneyBarLength,1 do
		MoneyBarText[i]:ClearAll()
	end
end

-- Change Text Colors
function MoneyBar.ChangeTextColor(mbr,mbg,mbb)
	for i=1,MoneyBarLength,1 do
		MoneyBarText[i]:SetFontColor(mbr,mbg,mbb,1)
	end
end

-- Reset the Text Frame's position after ClearAll() has been used
function MoneyBar.TextLoc()
    if MoneyBarSave.orient == "vert" then
        for i=1,MoneyBarLength,1 do
			if MoneyBarIcons[i]:GetVisible() then
				MoneyBarText[i]:SetPoint("TOPLEFT",bar,"TOPLEFT",0,MoneyBarIcons[i]:GetTop()-MoneyBarSave.y + 12)
			else
				MoneyBarText[i]:SetVisible(false)
			end
        end
    else
        for i=1,MoneyBarLength,1 do
			if MoneyBarIcons[i]:GetVisible() then
				MoneyBarText[i]:SetPoint("TOPLEFT",bar,"TOPLEFT",MoneyBarIcons[i]:GetRight()-MoneyBarSave.x,0)
			else
				MoneyBarText[i]:SetVisible(false)
			end
        end
    end
end

-- Gets the current amount of each currency
function MoneyBar.GetStack(a)
	local list = Inspect.Currency.List()
    local stack = -1
    for k,j in pairs(list) do
        currency[j] = Inspect.Currency.Detail(k)
        if currency[j].id == a then
            stack = currency[j].stack
            break
        else
            stack = 0
        end
    end
    if not stack then
        stack = -1
    end
	stack = tostring(stack)
	return stack
end

function MoneyBar.Reset()
	bar:ClearAll()
	MoneyBar.BuildAll()
end

-- Slash Commands other than scale and Scale currently
function MoneyBar.SlashHandler(args)
	local cmd = {}
    local numargs = 0
	local moneybarlanguage = Inspect.System.Language()
	for token in string.gmatch(args, "[^%s]+") do
			cmd[numargs] = token
			numargs = numargs + 1
	end
	-----------------------------------   GERMAN  --------------------------------------------------------------------------------
	if moneybarlanguage == "German" then
		if cmd[0] == "default" then
			MoneyBarSave = defaultSave;
			MoneyBar.Reset()
			print("Money Bar erfolgreich zurucksetzen zu default konfiguration.")
		elseif cmd[0] == "alpha" then
			if numargs ~= 2 then
				print("Bei falscher verwendung. /moneybar alpha <a>")
				return
			end
			MoneyBarSave.alpha = tonumber(cmd[1])/10
			bar:SetAlpha(MoneyBarSave.alpha)
		elseif cmd[0] == "filtern" then
			MoneyBar.Filter()
		elseif cmd[0] == "bewegen" then
			bar.fixedPos = not bar.fixedPos
			if bar.fixedPos then
				print("Bewegen getoggelt ab.")
			else
				print("Bewegen getoggelt auf. Ziehen sie die leiste, um es an eine neue position bewegen.")
			end
		elseif cmd[0] == "MaBstab" then
			if numargs ~= 2 then
				print("Bei falscher verwendung. /moneybar MaBstab <w>")
				return
			end
			local scale = cmd[1]
			scale = tonumber(scale)
			if not scale then
				print("Geben sie einen wert, um die breite einstellen (oder wenn hohe vertikale) der leiste (Default ist 1750)")
			end
			
			if MoneyBarSave.orient == "vert" and (scale > 2000 or scale < 200) then -- Minimum limitation is there because it doesn't align correctly when lower than the minimum. Maximum dimension actually still aligns fine... but I REALLY don't think anyone has a monitor that is > ####x2000 screen resolution. TODO: Remove/change this limitation when currency filtering is implemented.
				print("Ungultige anzahl skala. Bitte wählen sie eine zahl zwischen 200 und 2000.")
				return
			elseif MoneyBarSave.orient == "horiz" and (scale > 2100 or scale < 200) then -- Doesn't position correctly beyond these scales. TODO: Remove/change this limitation when currency filtering is implemented.
				print("Ungultige anzahl skala. Bitte wählen sie eine zahl zwischen 200 und 2100.")
				return
			end
			
			MoneyBarSave.scale = scale
			if not bar.fixedPos then -- We want the bar to still be movable after scaling if it was movable before scaling
				MoneyBar.Reset()
				bar.fixedPos = false
			else
				MoneyBar.Reset()
			end
			print("Erfolgreich gesetzt: " .. scale)
		elseif cmd[0] == "orient" then
			if numargs ~= 2 then
				print("Bei falscher verwendung. /moneybar orient <horiz/vert>")
			end
			if cmd[1] == "vert" then
				MoneyBarSave.orient = "vert"
				MoneyBarSave.scale = defaultScale.vert
				MoneyBarSave.y = 10
				MoneyBar.Reset()
				print("Money Bar orientierung erfolgreich gesetzt: vert")
			elseif cmd[1] == "horiz" then
				MoneyBarSave.orient = "horiz"
				MoneyBarSave.scale = defaultScale.horiz
				MoneyBarSave.x = 10
				MoneyBar.Reset()
				print("Money Bar orientierung erfolgreich gesetzt: horiz")
			else
				print("Bei falscher verwendung. /moneybar orient <horiz/vert>")
			end
			
		elseif cmd[0] == "helfen" then
			print("/moneybar bewegen wechselt die leiste, um beweglich zu sein. Wenn auf getoggelt, die leiste ist beweglichen durch ziehen mit der maus.")
			print("/moneybar default legt die messlatte an die vorgabe lage, breite, ausrichtung und farben.")
			print("/moneybar alpha <a> legt die messlatte der transparenz. 'a' eine zahl zwischen 0 und 10 mit 10 sein fester und 0 unsichtbar.")
			print("/moneybar MaBstab <w> konnen sie die breite oder hohe des balkens andern (default einstellung ist 1750).")
			print("/moneybar orient <horiz/vert> legt die messlatte fur horizontale oder vertikale.")
			print("/moneybar filtern offnet ein menu, mit dem sie auswahlen, welche wahrungen auf die spur erlaubt.")
			print("/moneybarcolor leiste <r g b/farbe> nimmt in farben oder RGB zahlen als r g b wo r, g, und b sind zwischen 0 und 255.")
			print("/moneybarcolor text <r g b/farbe> nimmt in farben oder RGB zahlen als r g b wo r, g, und b sind zwischen 0 und 255.")
			print("Strom farbe optionen sind schwarz, rot, grun, blau, braun, weiB, orange, und lila.")
		else
			print("Bei falscher verwendung.  Verwenden /moneybar helfen um eine liste der befehle zu sehen.")
		end
		-----------------------------------   FRENCH  --------------------------------------------------------------------------------
	elseif moneybarlanguage == "French" then
		if cmd[0] == "defaut" then
			MoneyBarSave = defaultSave;
			MoneyBar.Reset()
			print("Money Bar reinitialisé avec succes a la configuration par defaut.")
		elseif cmd[0] == "alpha" then
			if numargs ~= 2 then
				print("Une utilisation incorrecte. /moneybar alpha <a>")
				return
			end
			MoneyBarSave.alpha = tonumber(cmd[1])/10
			bar:SetAlpha(MoneyBarSave.alpha)
		elseif cmd[0] == "filtrer" then
			MoneyBar.Filter()
		elseif cmd[0] == "deplacer" then
			bar.fixedPos = not bar.fixedPos
			if bar.fixedPos then
				print("Deplacer bascule hors.")
			else
				print("Moving toggled sur. Faites glisser la barre pour la deplacer vers une nouvelle position.")
			end
		elseif cmd[0] == "echelle" then
			if numargs ~= 2 then
				print("Une utilisation incorrecte. /moneybar echelle <w>")
				return
			end
			local scale = cmd[1]
			scale = tonumber(scale)
			if not scale then
				print("Entrez un nombre pour definir la largeur (ou la hauteur si elles sont verticales) de la barre (Defaut est 1750)")
			end
			
			if MoneyBarSave.orient == "vert" and (scale > 2000 or scale < 200) then -- Minimum limitation is there because it doesn't align correctly when lower than the minimum. Maximum dimension actually still aligns fine... but I REALLY don't think anyone has a monitor that is > ####x2000 screen resolution. TODO: Remove/change this limitation when currency filtering is implemented.
				print("Un nombre invalide echelle. Choisir un nombre compris entre 200 et 2000.")
				return
			elseif MoneyBarSave.orient == "horiz" and (scale > 2100 or scale < 200) then -- Doesn't position correctly beyond these scales. TODO: Remove/change this limitation when currency filtering is implemented.
				print("Un nombre invalide echelle. Choisir un nombre compris entre 200 et 2100.")
				return
			end
			
			MoneyBarSave.scale = scale
			if not bar.fixedPos then -- We want the bar to still be movable after scaling if it was movable before scaling
				MoneyBar.Reset()
				bar.fixedPos = false
			else
				MoneyBar.Reset()
			end
			print("Money Bar echelle reussi a mettre a: " .. scale)
		elseif cmd[0] == "orient" then
			if numargs ~= 2 then
				print("Une utilisation incorrecte. /moneybar orient <horiz/vert>")
			end
			if cmd[1] == "vert" then
				MoneyBarSave.orient = "vert"
				MoneyBarSave.scale = defaultScale.vert
				MoneyBarSave.y = 10
				MoneyBar.Reset()
				print("Money Bar l'orientation correctement configure a: vert")
			elseif cmd[1] == "horiz" then
				MoneyBarSave.orient = "horiz"
				MoneyBarSave.scale = defaultScale.horiz
				MoneyBarSave.x = 10
				MoneyBar.Reset()
				print("Money Bar l'orientation correctement configure a: horiz")
			else
				print("Une utilisation incorrecte. /moneybar orient <horiz/vert>")
			end
			
		elseif cmd[0] == "aider" then
			print("/moneybar deplacer permet de basculer la barre pour etre mobile. Lorsqu'il est active, la barre est mobile en faisant glisser avec votre souris.")
			print("/moneybar defaut fixe la barre a la position par defaut, la largeur, l'orientation, et les couleurs")
			print("/moneybar alpha <a> etablit la transparence de la barre. 'a' est un nombre compris entre 0 et 10 avec 10 etant solide et 0 etant invisible")
			print("/moneybar echelle <w> vous permet de changer la largeur ou la hauteur de la barre (reglage par defaut est 1750)")
			print("/moneybar orient <horiz/vert> definit la barre a l'horizontale ou verticale")
			print("/moneybar filtrer fait apparaitre un menu qui vous permet de choisir quelles devises a suivre")
			print("/moneybarcolor bar <r g b/couleur> prend des couleurs RVB ou des numeros comme r g b ou r, g, et b est compris entre 0 et 255")
			print("/moneybarcolor text <r g b/couleur> prend des couleurs RVB ou des numeros comme r g b ou r, g, et b est compris entre 0 et 255")
			print("Options de couleur actuelles sont de couleur noire, rouge, vert, bleu, brun, blanc, orange et violet")
		else
			print("Une utilisation incorrecte.  Utiliser /moneybar aider pour voir une liste de commandes")
		end
	-----------------------------------   ENGLISH   --------------------------------------------------------------------------------
	else
		if cmd[0] == "default" then
			MoneyBarSave = defaultSave;
			MoneyBar.Reset()
			print("Money Bar successfully reset to default configuration.")
		elseif cmd[0] == "alpha" then
			if numargs ~= 2 then
				print("Incorrect usage. /moneybar alpha <a>")
				return
			end
			MoneyBarSave.alpha = tonumber(cmd[1])/10
			bar:SetAlpha(MoneyBarSave.alpha)
		elseif cmd[0] == "filter" then
			MoneyBar.Filter()
		elseif cmd[0] == "move" then
			bar.fixedPos = not bar.fixedPos
			if bar.fixedPos then
				print("Moving toggled off.")
			else
				print("Moving toggled on. Drag bar to move it to a new position.")
			end
		elseif cmd[0] == "scale" then
			if numargs ~= 2 then
				print("Incorrect usage. /moneybar scale <w>")
				return
			end
			local scale = cmd[1]
			scale = tonumber(scale)
			if not scale then
				print("Enter a number to set the width (or height if vertical) of the bar (Default is 1750)")
			end
			
			if MoneyBarSave.orient == "vert" and (scale > 2000 or scale < 200) then -- Minimum limitation is there because it doesn't align correctly when lower than the minimum. Maximum dimension actually still aligns fine... but I REALLY don't think anyone has a monitor that is > ####x2000 screen resolution. TODO: Remove/change this limitation when currency filtering is implemented.
				print("Invalid scale number. Please choose a number between 200 and 2000.")
				return
			elseif MoneyBarSave.orient == "horiz" and (scale > 2100 or scale < 200) then -- Doesn't position correctly beyond these scales. TODO: Remove/change this limitation when currency filtering is implemented.
				print("Invalid scale number. Please choose a number between 200 and 2100.")
				return
			end
			
			MoneyBarSave.scale = scale
			if not bar.fixedPos then -- We want the bar to still be movable after scaling if it was movable before scaling
				MoneyBar.Reset()
				bar.fixedPos = false
			else
				MoneyBar.Reset()
			end
			print("Money Bar scale successfully set to: " .. scale)
		elseif cmd[0] == "orient" then
			if numargs ~= 2 then
				print("Incorrect usage. /moneybar orient <horiz/vert>")
			end
			if cmd[1] == "vert" then
				MoneyBarSave.orient = "vert"
				MoneyBarSave.scale = defaultScale.vert
				MoneyBarSave.y = 10
				MoneyBar.Reset()
				print("Money Bar orientation successfully set to: vert")
			elseif cmd[1] == "horiz" then
				MoneyBarSave.orient = "horiz"
				MoneyBarSave.scale = defaultScale.horiz
				MoneyBarSave.x = 10
				MoneyBar.Reset()
				print("Money Bar orientation successfully set to: horiz")
			else
				print("Incorrect usage. /moneybar orient <horiz/vert>")
			end
			
		elseif cmd[0] == "help" then
			print("/moneybar move toggles the bar to be movable. When toggled on, the bar is movable by dragging with your mouse.")
			print("/moneybar default sets the bar to the default position,width, orientation, and colors")
			print("/moneybar alpha <a> sets the bar's transparency. 'a' is a number between 0 and 10 with 10 being solid and 0 being invisible")
			print("/moneybar scale <w> allows you to change the width or height of the bar (default setting is 1750)")
			print("/moneybar orient <horiz/vert> sets the bar to horizontal or vertical")
			print("/moneybar filter brings up a menu that allows you to pick which currencies to track")
			print("/moneybarcolor bar <r g b/color> takes in colors or RGB numbers as r g b where r, g, and b are between 0 and 255")
			print("/moneybarcolor text <r g b/color> takes in colors or RGB numbers as r g b where r, g, and b are between 0 and 255")
			print("Current color options are black, red, green, blue, brown, white, orange, and purple")
		else
			print("Not a valid command.  Use /moneybar help to see a list of commands")
		end
	end
end

-- Handles slash commands to change colors for the bar and text
function MoneyBar.Colors(arg)
	local a,r,g,b = arg:match("(%a+) (%d+) (%d+) (%d+)")
	if not r then
		a,r = arg:match("(%a+) (%a+)")
	end
	if a == "bar" then
		if r == "black" then
			bar:SetBackgroundColor(0,0,0)
		elseif r == "red" then
			bar:SetBackgroundColor(1,0,0)
		elseif r == "green" then
			bar:SetBackgroundColor(0,1,0)
		elseif r == "blue" then
			bar:SetBackgroundColor(0,0,1)
		elseif r == "brown" then
			bar:SetBackgroundColor(0.54,0.36,0.36)
		elseif r == "orange" then
			bar:SetBackgroundColor(1,0.65,0)
		elseif r == "white" then
			bar:SetBackgroundColor(1,1,1)
		elseif r == "purple" then
			bar:SetBackgroundColor(0.61,0.19,1)
		elseif r and g and b then
			r = tonumber(r)/255
			g = tonumber(g)/255
			b = tonumber(b)/255
			bar:SetBackgroundColor(r,g,b)
		end
	elseif a == "text" then
		if r == "black" then
			MoneyBar.ChangeTextColor(0,0,0)
		elseif r == "red" then
			MoneyBar.ChangeTextColor(1,0,0)
		elseif r == "green" then
			MoneyBar.ChangeTextColor(0,1,0)
		elseif r == "blue" then
			MoneyBar.ChangeTextColor(0,0,1)
		elseif r == "brown" then
			MoneyBar.ChangeTextColor(0.54,0.36,0.36)
		elseif r == "orange" then
			MoneyBar.ChangeTextColor(1,0.65,0)
		elseif r == "white" then
			MoneyBar.ChangeTextColor(1,1,1)
		elseif r == "purple" then
			MoneyBar.ChangeTextColor(0.61,0.19,1)
		elseif r and g and b then
			r = tonumber(r)/255
			g = tonumber(g)/255
			b = tonumber(b)/255
			bar:SetBackgroundColor(r,g,b)
		end
	else
		print("The command is /moneybarcolor <bar/text> <color/rgb>")
		print("Current color options are black, red, green, blue, brown, white, orange, and purple")
	end
end

table.insert(Command.Slash.Register("moneybar"),{MoneyBar.SlashHandler,"Money","Slash Commands"})
table.insert(Command.Slash.Register("moneybarcolor"),{MoneyBar.Colors,"Money","Color Slash Commands"})
table.insert(Event.Addon.Load.End,{MoneyBar.Initialize,"Money","Create UI"})
table.insert(Event.Currency,{MoneyBar.SetText,"Money","Update"})
table.insert(Event.Unit.Availability.Full,{MoneyBar.WorkAround,"Money","Fix error of blank bar"})
