﻿local mb_filterui = UI.CreateFrame("SimpleWindow","Filter UI",moneybar_main)
local mb_filterlist = UI.CreateFrame("SimpleList","Currency List",moneybar_main)
local mb_sortlist = UI.CreateFrame("SimpleList","Sortable Currency List",moneybar_main)
local mb_selected = UI.CreateFrame("RiftButton","Selected Okay Button",moneybar_main)
local mb_sorted = UI.CreateFrame("RiftButton","Sorted Okay Button",moneybar_main)
local mb_helpframe = UI.CreateFrame("Frame","Frame for information",moneybar_main)
local mb_help = UI.CreateFrame("Text","Filter Help Text",moneybar_main)

local mb_previousitem = {item = "",index = 0}

function MoneyBar.BuildFilter()
	mb_filterui:SetVisible(false)
	mb_filterui:SetCloseButtonVisible(false)
	mb_filterui:SetPoint("TOPLEFT",moneybar_main,"TOPLEFT",100,100)
	mb_filterui:SetLayer(0)
	mb_filterui:SetTitle("Money Bar")
	mb_filterui:SetWidth(600)
	
	mb_filterlist:SetVisible(false)
	mb_filterlist:SetPoint("TOPLEFT",mb_filterui,"TOPLEFT",20,50)
	mb_filterlist:SetLayer(1)
	mb_filterlist:SetFontSize(15)
	mb_filterlist:SetBackgroundColor(0,0,0,0)
	mb_filterlist:SetSelectionMode("multi")
	mb_filterlist:SetEnabled(false)
	mb_filterlist:SetWidth(220)
	
	mb_sortlist:SetVisible(false)
	mb_sortlist:SetPoint("TOPLEFT",mb_filterui,"TOPLEFT",310,50)
	mb_sortlist:SetLayer(1)
	mb_sortlist:SetFontSize(15)
	mb_sortlist:SetBackgroundColor(0,0,0,0)
	mb_sortlist:SetSelectionMode("single")
	mb_sortlist:SetEnabled(false)
	mb_sortlist:SetWidth(220)
	
	mb_selected:SetVisible(false)
	mb_selected:SetPoint("TOPLEFT",mb_filterui,"TOPLEFT",mb_filterlist:GetLeft(),mb_filterlist:GetBottom())
	mb_selected:SetLayer(1)
	mb_selected:SetSkin("default")
	mb_selected:SetText("OKAY")
	mb_selected:SetEnabled(false)
	
	mb_sorted:SetVisible(false)
	mb_sorted:SetPoint("TOPLEFT",mb_filterui,"TOPLEFT",mb_sortlist:GetLeft(),mb_sortlist:GetBottom())
	mb_sorted:SetLayer(1)
	mb_sorted:SetSkin("default")
	mb_sorted:SetText("DONE")
	mb_sorted:SetEnabled(false)
	
	mb_helpframe:SetVisible(false)
	mb_helpframe:SetPoint("TOPLEFT",mb_filterui,"TOPLEFT",mb_filterui:GetRight(),mb_filterui:GetTop())
	mb_helpframe:SetBackgroundColor(0,0,0,0.8)
	mb_helpframe:SetWidth(300)
	mb_helpframe:SetHeight(150)
	mb_helpframe:SetLayer(0)
	
	mb_help:SetVisible(false)
	mb_help:SetPoint("TOPLEFT",mb_filterui,"TOPLEFT",mb_filterui:GetRight(),mb_filterui:GetTop())
	mb_help:SetLayer(1)
	mb_help:SetFontSize(15)
	mb_help:SetText("Select currencies by clicking on them in the" .. "\n" .. "right list." .. "\n" .. "Then when done click on OKAY." .. "\n" .. "In the left list that appears sort by click".. "\n" .. "on the item you want to move" .. "\n" .. "then click on the location you want it to be." .. "\n" .. "The items will swap places.")
end

function MoneyBar.Filter()
	local mb_currnames = {}
	local mb_currlist = Inspect.Currency.List()
	for id,_ in pairs(mb_currlist) do
		local mb_currency = Inspect.Currency.Detail(id)
		if mb_currency.name == "Platinum, Gold, Silver" then
			table.insert(mb_currnames,"Platinum")
		else
			table.insert(mb_currnames,mb_currency.name)
		end
	end
	table.sort(mb_currnames)
	mb_filterlist:SetItems(mb_currnames)
	local left,top,right,bottom = mb_filterlist:GetBounds()
	mb_filterui:SetHeight(bottom - top + 100)
	mb_selected:SetPoint("TOPLEFT",mb_filterui,"TOPLEFT",30,bottom-100)
	mb_sorted:SetPoint("TOPLEFT",mb_filterui,"TOPLEFT",mb_filterui:GetWidth()-mb_sorted:GetWidth()-30,bottom-100)
	mb_selected:SetEnabled(true)
	mb_selected:SetVisible(true)
	mb_sorted:SetVisible(true)
	mb_filterui:SetVisible(true)
	mb_filterui:SetCloseButtonVisible(true)
	mb_filterlist:SetVisible(true)
	mb_filterlist:SetEnabled(true)
	mb_helpframe:SetVisible(true)
	mb_help:SetVisible(true)
end

function mb_selected.Event:LeftPress()
	local mb_getselected = mb_filterlist:GetSelectedItems()
	-- local mb_indices = {}
	-- for i=1,table.maxn(mb_getselected),1 do
		-- table.insert(mb_indices,i)
	-- end
	mb_sortlist:SetItems(mb_getselected)
	--mb_sorted:SetPoint("TOPLEFT",mb_filterui,"TOPLEFT",mb_sortlist:GetLeft(),mb_sortlist:GetBottom())
	mb_sorted:SetEnabled(true)
	mb_sortlist:SetVisible(true)
	mb_sortlist:SetEnabled(true)
end

--Switch the previous item selected and the current item selected
function mb_sortlist.Event:ItemSelect(item,value,index)
	if mb_previousitem.item == "" then
		mb_previousitem.item = item
		mb_previousitem.index = index
	else
		local mb_temptable = {sel = item,ind = index}
		local mb_switch = mb_sortlist:GetItems()
		local prev_index = 0
		local curr_index = 0
		for i=1,table.maxn(mb_switch),1 do
			if mb_switch[i] == item then
				curr_index = i
			end
			if mb_switch[i] == mb_previousitem.item then
				prev_index = i
			end
		end
		table.remove(mb_switch,curr_index)
		table.insert(mb_switch,curr_index,mb_previousitem.item)
		table.remove(mb_switch,prev_index)
		table.insert(mb_switch,prev_index,item)
		mb_sortlist:SetItems(mb_switch)
		mb_previousitem = {item = "",index = 0}
	end
	
end

function mb_sorted.Event:LeftPress()
	
	MoneyBarSave.filter = mb_sortlist:GetItems()
	-- for i=1,table.maxn(MoneyBarSave.filter),1 do
		-- MoneyBarFilterButton[i]:SetVisible(false)
	-- end
	print("Showing only the following:")
	for i=1,table.maxn(MoneyBarSave.filter),1 do
		print(MoneyBarSave.filter[i])
	end
	MoneyBar.BuildAll()
	
	mb_filterlist:SetItems({})
	mb_selected:SetEnabled(false)
	mb_selected:SetVisible(false)
	mb_sorted:SetVisible(false)
	mb_filterui:SetVisible(false)
	mb_filterui:SetCloseButtonVisible(false)
	mb_filterlist:SetVisible(false)
	mb_filterlist:SetEnabled(false)
	mb_sortlist:SetItems({})
	mb_sorted:SetEnabled(false)
	mb_sortlist:SetVisible(false)
	mb_sortlist:SetEnabled(false)
	mb_helpframe:SetVisible(false)
	mb_help:SetVisible(false)
end

function mb_filterui.Event:Close()
	mb_filterlist:SetItems({})
	mb_selected:SetEnabled(false)
	mb_selected:SetVisible(false)
	mb_sorted:SetVisible(false)
	mb_filterui:SetVisible(false)
	mb_filterui:SetCloseButtonVisible(false)
	mb_filterlist:SetVisible(false)
	mb_filterlist:SetEnabled(false)
	mb_sortlist:SetItems({})
	mb_sorted:SetEnabled(false)
	mb_sortlist:SetVisible(false)
	mb_sortlist:SetEnabled(false)
	mb_helpframe:SetVisible(false)
	mb_help:SetVisible(false)
end